{=======================================================================================================================

  SiteMap Make

       .

========================================================================================================================

  :

  31.03.2019 [*]   .
  27.03.2019 [*]   .
  24.10.2018 [!]    .     .
  05.04.2018 [+]  TComboBox.
  17.02.2018 [*]   00.
  02.02.2018 [+]  .
  01.02.2018 [!]  .

========================================================================================================================
  Copyright 20182019 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: fmMain.pas,v 1.7 2019/03/27 20:24:41 tsk Exp $
=======================================================================================================================}
unit fmMain;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls, StdCtrls, StrUtils,
      PropStorageEh, ComCtrls, ToolWin, ActnList, ImgList, PropFilerEh, System.Actions, System.ImageList, Vcl.Buttons,
      System.Win.Registry,
      // Comming:
      CommingFile, CommingVersionInfo, CommingString, CommingInternet, CommingDialog;

type
  TMainFM = class(TForm)
    lbResult: TListBox;
    psFile: TPropStorageEh;
    reMain: TRegPropStorageManEh;
    pnTop: TPanel;
    btRun: TBitBtn;
    cbPart: TComboBox;
    btDelete: TBitBtn;
    blEdit: TBevel;
    edPath: TEdit;
    Label1: TLabel;
    btSave: TBitBtn;
    psProp: TPropStorageEh;
    edSite: TEdit;
    Label2: TLabel;
    edExt: TEdit;
    edFile: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure btRunClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure cbPartChange(Sender: TObject);
    procedure psFileAfterLoadProps(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
    procedure psPropAfterLoadProps(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
  end;

var MainFM: TMainFM;

implementation

{$R *.dfm}
//======================================================================================================================
{ TMainFM }
//======================================================================================================================
procedure TMainFM.FormCreate(Sender: TObject);
begin
  lbResult.Items.Add( GetVersion );
end;
//======================================================================================================================
procedure TMainFM.psFileAfterLoadProps(Sender: TObject);
begin
//  cbPart.Items.s
  if cbPart.ItemIndex < 0 then cbPart.ItemIndex := 0;
  cbPartChange(Sender);
end;
//======================================================================================================================
procedure TMainFM.psPropAfterLoadProps(Sender: TObject);
begin
  if edExt.Text = EmptyStr  then edExt.Text := 'htm';
  if edFile.Text = EmptyStr then edFile.Text := 'sitemap.txt';
end;
//======================================================================================================================
procedure TMainFM.cbPartChange(Sender: TObject);
begin
  if ( cbPart.ItemIndex >= 0 ) then begin
    psProp.Section := 'Part\' + cbPart.Text;
    psProp.LoadProperties;
//    lbResult.Items.Add( psProp.Section );
  end;
end;
//======================================================================================================================
procedure TMainFM.btSaveClick(Sender: TObject);
  var s: String;
      p: Integer;
begin
  if (edPath.Text = EmptyStr) then Exit;
  if ( edPath.SelText <> EmptyStr )
    then s := edPath.SelText
    else s :=  edPath.Text;
  s := LowerCase( s );
  s := StringReplace( s, ':', '', [rfReplaceAll, rfIgnoreCase] );
  s := StringReplace( s, '\', '-', [rfReplaceAll, rfIgnoreCase] );
  s := StringReplace( s, '.', '-', [rfReplaceAll, rfIgnoreCase] );
  p := cbPart.Items.IndexOf( s );
  if p < 0 then p := cbPart.Items.Add( s );
  cbPart.ItemIndex := p;
  psProp.Section := 'Part\' + cbPart.Text;
  psProp.SaveProperties;
end;
//======================================================================================================================
procedure TMainFM.btDeleteClick(Sender: TObject);
  var reg: TRegistry;
//      pr: Boolean;
begin
  if ShowWarning( ' %s?', [ cbPart.Text ]) then begin
    reg := TRegistry.Create( KEY_WRITE );
    reg.RootKey := reMain.Key;
//    ShowMessage( reMain.Path + '\Part\' + cbPart.Text );
    reg.DeleteKey( reMain.Path + '\Part\' + cbPart.Text );
    reg.Free;
    cbPart.Items.Delete( cbPart.ItemIndex );
    cbPart.ItemIndex := 0;
  end;
end;
//======================================================================================================================
procedure TMainFM.btRunClick(Sender: TObject);
  var ph, ex, ur, fl: String;
      FileList: TStringList;
      co: Integer;
begin
  ComboBoxItemSave( cbPart );
  cbPartChange(Sender);
  if ( cbPart.ItemIndex < 0 ) then begin
    lbResult.Items.Add( ':   .' );
    Exit;
  end;
  psProp.SaveProperties;
//  lbResult.Clear;
  ph := Trim ( edPath.Text );
  if ( RightStr( ph, 1 ) <> '\' ) then ph := ph + '\';
  if ( ph = EmptyStr ) then begin
    lbResult.Items.Add( ':    .' );
    Exit;
  end;
  if not DirectoryExists( ph ) then begin
    lbResult.Items.Add( ':   .' );
    Exit;
  end;
  ex := Trim ( edExt.Text );
  if ( ex = EmptyStr ) then begin
    lbResult.Items.Add( ':    .' );
    Exit;
  end;
  ur := Trim ( edSite.Text );
  if ( RightStr( ur, 1 ) <> '/' ) then ur := ur + '/';
  if ( ur = EmptyStr ) then begin
    lbResult.Items.Add( ':   URL .' );
    Exit;
  end;
  fl := Trim ( edFile.Text );
  if ( fl = EmptyStr ) then begin
    lbResult.Items.Add( ':    .' );
    Exit;
  end;
  lbResult.Items.Add( '...' );
  FileList := TStringList.Create;
  FileList.Clear;
  Screen.Cursor := crHourGlass;
  co := SiteMap( ph, ex, '|_vti_|00|', ur,  fl );
//  RecurseDir( ph, ex, FileList, '|_vti_|00|' );
//  lbFile.Items.Assign( FileList );
//  if ( FileList.Count > 0 ) then begin
//    for i := 0 to FileList.Count - 1 do begin
//      if Pos ( '00', lbFile.Items[i] ) > 0 then Continue;
//      FileList[i] := ReplaceStr( ReplaceStr( FileList[i], ph, ur ), '\', '/' );
//    end;
//    FileList.SaveToFile( ph + 'sitemap.txt');
//  end;
//  lbResult.Items.Add( FileList[0] );
//  lbResult.Items.Add( '...' );
  lbResult.Items.Add( Format( ' %s,  : %d.', [ ph, co ]));
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
end.
